Pls review this code and suggest if it can be written in a better way


 
Thread Tools Search this Thread
Top Forums UNIX for Advanced & Expert Users Pls review this code and suggest if it can be written in a better way
# 1  
Old 02-16-2009
Pls review this code and suggest if it can be written in a better way

Pls review this code and provide your feedbacks to make it more efficient.I have tried to add to each section.

Code:
Code 
###############################################################
#!/bin/ksh
RRSRC=/test
RREP=/test
#Directories
test_dir=/test
#Imp Files
FILENAME=/test/files.txt
# rename the datasets to test1 and test2 ----Is there a better method to rename at RENAME STEP
llll=test1.sas7bdat
mmmm=test2.sas7bdat
set +x
# Sas prg to be executed
pgm_name=from_tytt
rpt_pgm_name=ppppp
export log=$RLOG/${seq_nbr}_${pgm_name}_${year}${emth}.log
export log1=$RLOG/${seq_nbr}_${rpt_pgm_name}_${year}${emth}.log
#
#  read in the ending month as they are used to process the files for that
#  Quarter.
#
touch ${log}
touch ${log1}
echo ${pgm_name}
echo ${rpt_pgm_name}

log_date=`date +%m%d%y`
echo ${log_date}
echo "Starting SAS"

#Variable for 2 digit month calculation
a=0

# Create the directory with the eod date this directory will be purged at the completion of the process
eod=`date +%m%d%y`
archive_dir=/test/"$eod"
mkdir $archive_dir
#Read the files for the quarterie if it for the quarter =1 then  read files for jan feb march
# the files start with 
#'a_d_c'
#'kpp_s' 
#'ax_P_Tl_Gr' 
#'T_P_al_Gd_At' 
#'x_P_Rd'
#'a_P_l_ot_Ng' 
# The FILENAME contains these strings and is used to read only these files 
# the files are in the string_yyyymmdd_hhmmss.txt format so calculate the mth variable
# to get a two digit number
while IFS= read -r LINE
do
Mth=9
COUNT=1
while [ $COUNT -lt 4 ];
do
  if [ $Mth -lt 10 ];  then
     Mth="$a$Mth"
  fi
#  Copy the files tothe temporary archive directory
   cp "$test_dir/$LINE"_"$YEAR$Mth"*.txt $archive_dir/.
  Mth=`expr $Mth - 1`
  COUNT=`expr $COUNT + 1`
done
done < "$FILENAME"

# From the list of files for the quarter
# read each file and create dataset.
# Since each file has different variable so 
# pass the number of variables dynamically
# to the Sas prg.Export the file name(obj) and the number of variable parameter(var2)
ls -1 "$archive_dir|while read obj
  do
    echo "Inside DO $LINE loop"
    export obj
    echo  $obj
if [ "$LINE" = 'a_d_c' ];then var2=var25
   elif [ "$LINE" = 'kpp_s' ];then var2=var11
            elif [ "$LINE" = 'ax_P_Tl_Gr' ];then var2=var7
                 elif [ "$LINE" = 'T_P_al_Gd_At' ];then var2=var7
                     elif [ "$LINE" = 'x_P_Rd' ];then var2=var17
                         elif [ "$LINE" = 'a_P_l_ot_Ng' ];then var2=var7
fi
echo $LINE
export var2
echo $var2
  /sas $RRSRC/$pgm_name.sas -print $RREP/$pgm_name -log $log
  return_code=$?
  if [ $return_code -gt 1 ]
  then
        echo "$pgm_name.sas failed -- return code=$return_code"
        exit $return_code
fi
  done
# For the process we just need to two datasets but we need the latest ones. 
#RENAME STEP
do
  ls -r1 "$archive_dir/a_d_c_????????_??????_??????.????????|sort -t2 +1 -r|head -1|while read obj
  do
    mv $obj $llll
 done
done
do
  ls -r1 "$archive_dir/x_P_Rd_????????_??????_??????.????????|sort -t2 +1 -r|head -1|while read obj
  do
    mv $obj $mmmmm
 done
done
# End of RENAME Step
#  read and process further
 /sas $RRSRC/$rpt_pgm_name.sas -print $RREP/$rpt_pgm_name -log $log1
return_code=$?
  if [ $return_code -gt 1 ]
  then
        echo "$rpt_pgm_name.sas failed -- return code=$return_code"
        exit $return_code
fi
# purge the archive directory
_purge $archive_dir
_purge()
    {
            # there had better be a directory
            if [ ! -d $1 ]; then
     echo $1: No such directory 1>&2
     return
            fi
    }
###############################################

# 2  
Old 02-17-2009
Your do... done statements don't parse.

What is the purpose of the script, please? Not the algorithm or mechanism, but its overall goal.
# 3  
Old 02-17-2009
Thanks it was a good catch. I had moved some code from one part of the script to another which led to this.I am making some changes and will be reposting this code in a short while.

The Objective of the code:

I am trying to process a set of file which follow a naming pattern.The naming pattern is of the king

string_yyyymmdd_hhmmss_YYYYMM.txt

The string is contained in the file used.

I need to process all the files for a quarter using process1 and two out this set using another process. The two are to be selected using the latest yyyymmdd_hhmmss value containe din the file name.

Thanks
# 4  
Old 02-17-2009
I was highly confused by this sentence:
Quote:
I need to process all the files for a quarter using process1 and two out this set using another process. The two are to be selected using the latest yyyymmdd_hhmmss value containe din the file name.
Perhaps you can re-phrase it?
# 5  
Old 02-17-2009
Hi

I have made the chnges to the code and its running now. i have added PROCESS1 and PROCESS2 to indicate what files are to be processed under each PROCESS.I have modified the code so as not to reflect the actual data so there are chances that copy pasting it might not run.Pls review the functionality and suggest if it can be implemented in a better way.

Thanks






Code:
Code 
###############################################################
#!/bin/ksh
RRSRC=/test
RREP=/test
#Directories
test_dir=/test
#Imp Files
FILENAME=/test/files.txt
# rename the datasets to test1 and test2 ----Is there a better method to rename at RENAME STEP
llll=test1.sas7bdat
mmmm=test2.sas7bdat
set +x
# Sas prg to be executed
pgm_name=from_tytt
rpt_pgm_name=ppppp
export log=$RLOG/${seq_nbr}_${pgm_name}_${year}${emth}.log
export log1=$RLOG/${seq_nbr}_${rpt_pgm_name}_${year}${emth}.log
#
#  read in the ending month as they are used to process the files for that
#  Quarter.
#
touch ${log}
touch ${log1}
echo ${pgm_name}
echo ${rpt_pgm_name}
log_date=`date +%m%d%y`
echo ${log_date}
echo "Starting SAS"
#Variable for 2 digit month calculation
a=0
# Create the directory with the eod date this directory will be purged at the completion of the process
eod=`date +%m%d%y`
echo $eod
export eod
archive_dir=/test/"$eod"
mkdir $archive_dir
#Read the files for the quarterie if it for the quarter =1 then  read files for jan feb march
# the files start with 
#'a_d_c'
#'kpp_s' 
#'ax_P_Tl_Gr' 
#'T_P_al_Gd_At' 
#'x_P_Rd'
#'a_P_l_ot_Ng' 
# The FILENAME contains these strings and is used to read only these files 
# the files are in the string_yyyymmdd_hhmmss.txt format so calculate the mth variable
# to get a two digit number
while IFS= read -r LINE
do
Mth=9
COUNT=1
while [ $COUNT -lt 4 ];
do
  if [ $Mth -lt 10 ];  then
     Mth="$a$Mth"
  fi
#  Copy the files tothe temporary archive directory
   cp "$test_dir/$LINE"_"$YEAR$Mth"*.txt $archive_dir/.
  Mth=`expr $Mth - 1`
  COUNT=`expr $COUNT + 1`
done
done < "$FILENAME"
# From the list of files for the quarter
# read each file and create dataset.
# Since each file has different variable so 
# pass the number of variables dynamically
# to the Sas prg.Export the file name(obj) and the number of variable parameter(var2)
ls -1 "$archive_dir|while read obj
  do
    LINE=`basename $obj .txt`
    echo $LINE
    export LINE
    echo "Inside DO $LINE loop"
    export obj
    echo  $obj
if [ `nawk -v a="$obj" -v b="a_d_c" 'BEGIN{print match(a,b)}'` -ne 0 ];then var2=var25
   elif [ `nawk -v a="$obj" -v b="kpp_s" 'BEGIN{print match(a,b)}'` -ne 0 ];then var2=var11
            elif [ `nawk -v a="$obj" -v b="ax_P_Tl_Gr" 'BEGIN{print match(a,b)}'` -ne 0 ];then var2=var7
                 elif [ `nawk -v a="$obj" -v b="T_P_al_Gd_At" 'BEGIN{print match(a,b)}'` -ne 0 ];then var2=var7
                     elif [ `nawk -v a="$obj" -v b="x_P_Rd" 'BEGIN{print match(a,b)}'` -ne 0  ];then var2=var17
                         elif [ `nawk -v a="$obj" -v b="a_P_l_ot_Ng" 'BEGIN{print match(a,b)}'` -ne 0  ];then var2=var7
fi
export var2
echo $var2
 
# PROCESS 1 -All files to be processed present in the archive directory
  /sas $RRSRC/$pgm_name.sas -print $RREP/$pgm_name -log $log
  return_code=$?
  if [ $return_code -gt 1 ]
  then
        echo "$pgm_name.sas failed -- return code=$return_code"
        exit $return_code
fi
  done
# For the process we just need to two datasets but we need the latest ones. 
#RENAME STEP
do
  ls -r1 "$archive_dir/a_d_c_????????_??????_??????.????????|sort -t2 +1 -r|head -1|while read obj
  do
    mv $obj $llll
 done
done
do
  ls -r1 "$archive_dir/x_P_Rd_????????_??????_??????.????????|sort -t2 +1 -r|head -1|while read obj
  do
    mv $obj $mmmmm
 done
done
# End of RENAME Step
#  PROCESS 2 read and process further .ONLY THE 
# latest datasets llll=test1.sas7bdat and
#  mmmm=test2.sas7bdat need to processed.

 /sas $RRSRC/$rpt_pgm_name.sas -print $RREP/$rpt_pgm_name -log $log1
return_code=$?
  if [ $return_code -gt 1 ]
  then
        echo "$rpt_pgm_name.sas failed -- return code=$return_code"
        exit $return_code
fi
# purge the archive directory
_purge $archive_dir
_purge()
    {
            # there had better be a directory
            if [ ! -d $1 ]; then
     echo $1: No such directory 1>&2
     return
            fi
    }
###############################################

# 6  
Old 02-17-2009
What's wrong with the code now? Doesn't work? Hard to maintain? Slow?

At first blush, when I see "if [ nawk ... elif [ nawk ..." it really makes me want to convert the whole damn thing to a real scripting language (python, ruby, or perl, in order of my personal preference).
--
Quentin
Login or Register to Ask a Question

Previous Thread | Next Thread

7 More Discussions You Might Find Interesting

1. Solaris

Backup or flash archive. Pls suggest correct way.

Hello mates, There is a task of Sol 10 installation and configuration of it by customer's demands on a few Solaris boxes (SPARC). The boxes have different capacity of IDE disks and one root ufs file system per box. I have completely prepared one of them. It took couple of days. "Completely... (0 Replies)
Discussion started by: wolfgang
0 Replies

2. What is on Your Mind?

Please Review Our Unix/Linux Timeline and Suggest More Events and Milestones

In case you have not seen it, we have a UNIX and Linux Timeline on FB. If you have a few free moments, could you review the timeline and post back here in this thread with your suggestions and ideas for new entries and milestones? Thanks! (1 Reply)
Discussion started by: Neo
1 Replies

3. Shell Programming and Scripting

Please suggest some changes in my code

Hi All, I have made the following code which is taking 10-15 mins to execute completely. Here the file am using is very big( around 1050993843). Can any one make some changes in my code which reduces the time it takes to execute as am very much new to Unix(learner). One more thing, i have... (10 Replies)
Discussion started by: madhavsunduru
10 Replies

4. UNIX for Dummies Questions & Answers

Where can I review the source code?

A very n00b question: After compiling and installing software, where does the original source code reside? I'd like to study the source code of some of the ports I've installed. Thanks! :D (1 Reply)
Discussion started by: Aaron Van
1 Replies

5. Shell Programming and Scripting

Can someone review my code tell me where I am going wrong?

Started writing my code. my read input is not even asking nor working? And I get a EOF script error. echo "1) aragorn.domain.net" echo "2) marvel.domain.net" echo "3) athena.domain.net" echo "4) gandalf.domain.net" echo "5) griffin.domain.net" echo "What server would you like... (4 Replies)
Discussion started by: chrchcol
4 Replies

6. Shell Programming and Scripting

Can some review my code would be appreicated?

I am getting an error "ftpNotes.sh: syntax error at line 8 : `<<' unmatched" #!/bin/ksh PATH=/usr/sbin/:/usr/bin:/usr/ucb:/etc:/usr/local/bin:. cd $HOME if ;then if ; then echo 'DSC file already ftp to epm server' else ftp -n epmdev00 <<SCRIPT... (1 Reply)
Discussion started by: sibghat
1 Replies

7. Shell Programming and Scripting

a piece of code, plz help to review

use "getopts" to get params from command. Need replace black with a specified string like "%20 DEFAULT_DELIM=%20 ... while getopts dek:f:t:vh OPTION do case $OPTION in t) DELIM=`tvar=/'"$OPTARG"'/ svar="$DEFAULT_DELIM" awk 'BEGIN{T=ENVIRON;S=ENVIRON; while(index(T,S)!=0){S=S"0"};print... (0 Replies)
Discussion started by: anypager
0 Replies
Login or Register to Ask a Question